## yquake2 8.20+ctf1.09+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

# Print a message that using the Makefiles is recommended.
message(NOTICE: " The CMakeLists.txt is unmaintained. Use the Makefile if possible.")

# Enforce "Debug" as standard build type.
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# CMake project configuration.
project(yquake2 C)

# Cmake module search path.
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/stuff/cmake/modules ${CMAKE_MODULE_PATH})
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED OFF)

if(YQUAKE2LIBS)
	if(CMAKE_CROSSCOMPILING)
		set(CMAKE_FIND_ROOT_PATH ${YQUAKE2LIBS})
	else()
		set(ENV{CMAKE_PREFIX_PATH} ${YQUAKE2LIBS})
	endif()

	set(ENV{OPENALDIR} ${YQUAKE2LIBS})
	set(ENV{SDL2DIR} ${YQUAKE2LIBS})
endif()

# Add extended path for FreeBSD and Homebrew on OS X.
list(APPEND CMAKE_PREFIX_PATH /usr/local)

if (MSVC)
	add_compile_options(/MP) # parallel build (use all cores, or as many as configured in VS)

	# ignore some compiler warnings
	add_compile_options(/wd4244 /wd4305) # possible loss of data/truncation (double to float etc; ignore)
	add_compile_options(/wd4018) # signed/unsigned missmatch
	add_compile_options(/wd4996) # 'function': was declared deprecated (like all that secure CRT stuff)
	# don't show me warnings for system headers, why the fuck isn't this default
	add_compile_options(/experimental:external /external:W0)
else() # GCC/clang/mingw
# Enforce compiler flags:
#  -Wall                -> More warnings
#  -fno-strict-aliasing -> Quake 2 is far away from strict aliasing
#  -fwrapv              -> Make signed integer overflows defined
#  -fvisibility=hidden	-> Force defaultsymbol visibility to hidden
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fno-strict-aliasing -fwrapv -fvisibility=hidden")

# Use -O2 as maximum optimization level. -O3 has it's problems with yquake2.
string(REPLACE "-O3" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif() # MSVC'S else-case

# Switch off some annoying warnings
if (${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-braces")
elseif (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
	if (CMAKE_C_COMPILER_VERSION GREATER 7.99)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format-truncation -Wno-format-overflow")
	endif()
endif()

# Compilation time options.
option(CURL_SUPPORT "cURL support" ON)
option(OPENAL_SUPPORT "OpenAL support" ON)
option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)

set(SYSTEMDIR "" CACHE STRING "Override the system default directory")

# These variables will act as our list of include folders and linker flags.
set(yquake2IncludeDirectories)
set(yquake2LinkerDirectories)
set(yquake2LinkerFlags)
set(yquake2ClientLinkerFlags)
set(yquake2ServerLinkerFlags)
set(yquake2OpenGLLinkerFlags)
set(yquake2VulkanLinkerFlags)
set(yquake2SDLLinkerFlags)
set(yquake2ZLibLinkerFlags)

# Set directory locations (allowing us to move directories easily)
set(SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/src)
set(BACKENDS_SRC_DIR ${SOURCE_DIR}/backends)
set(COMMON_SRC_DIR ${SOURCE_DIR}/common)
set(GAME_SRC_DIR ${SOURCE_DIR}/game)
set(SERVER_SRC_DIR ${SOURCE_DIR}/server)
set(CLIENT_SRC_DIR ${SOURCE_DIR}/client)
set(REF_SRC_DIR ${SOURCE_DIR}/client/refresh)

# Operating system.
set(YQ2OSTYPE "${CMAKE_SYSTEM_NAME}" CACHE STRING "Override operation system type")
add_definitions(-DYQ2OSTYPE="${YQ2OSTYPE}")

# Architecture string
# work around CMake's useless/broken CMAKE_SYSTEM_PROCESSOR (taken from dhewm3)

set(cpu ${CMAKE_SYSTEM_PROCESSOR})

# Originally, ${CMAKE_SYSTEM_PROCESSOR} was supposed to contain the *target* CPU, according to CMake's documentation.
# As far as I can tell this has always been broken (always returns host CPU) at least on Windows
# (see e.g. https://cmake.org/pipermail/cmake-developers/2014-September/011405.html) and wasn't reliable on
# other systems either, for example on Linux with 32bit userland but 64bit kernel it returned the kernel CPU type
# (e.g. x86_64 instead of i686). Instead of fixing this, CMake eventually updated their documentation in 3.20,
# now it's officially the same as CMAKE_HOST_SYSTEM_PROCESSOR except when cross-compiling (where it's explicitly set)
# So we gotta figure out the actual target CPU type ourselves..
if(NOT (CMAKE_SYSTEM_PROCESSOR STREQUAL CMAKE_HOST_SYSTEM_PROCESSOR))
	# special case: cross-compiling, here CMAKE_SYSTEM_PROCESSOR should be correct, hopefully
	# (just leave cpu at ${CMAKE_SYSTEM_PROCESSOR})
elseif(MSVC)
	message(DEBUG "CMAKE_GENERATOR_PLATFORM: ${CMAKE_GENERATOR_PLATFORM}")
	if(CMAKE_GENERATOR_PLATFORM STREQUAL "Win32")
		set(cpu "i386")
	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "x64")
		set(cpu "x86_64")
	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM")
		# at least on RPi 32bit, gcc -dumpmachine outputs "arm-linux-gnueabihf",
		#  so we'll use "arm" there => use the same for 32bit ARM on MSVC
		set(cpu "arm")
	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
		set(cpu "arm64")
	else()
		message(FATAL_ERROR "Unknown Target CPU/platform ${CMAKE_GENERATOR_PLATFORM}")
	endif()
	message(DEBUG "  => CPU architecture extracted from that: \"${cpu}\"")
else() # not MSVC and not cross-compiling, assume GCC or clang (-compatible), seems to work for MinGW as well
	execute_process(COMMAND ${CMAKE_C_COMPILER} "-dumpmachine"
	                RESULT_VARIABLE cc_dumpmachine_res
	                OUTPUT_VARIABLE cc_dumpmachine_out)
	if(cc_dumpmachine_res EQUAL 0)
		string(STRIP ${cc_dumpmachine_out} cc_dumpmachine_out) # get rid of trailing newline
		message(DEBUG "`${CMAKE_C_COMPILER} -dumpmachine` says: \"${cc_dumpmachine_out}\"")
		# gcc -dumpmachine and clang -dumpmachine seem to print something like "x86_64-linux-gnu" (gcc)
		# or "x64_64-pc-linux-gnu" (clang) or "i686-w64-mingw32" (32bit mingw-w64) i.e. starting with the CPU,
		# then "-" and then OS or whatever - so use everything up to first "-"
		string(REGEX MATCH "^[^-]+" cpu ${cc_dumpmachine_out})
		message(DEBUG "  => CPU architecture extracted from that: \"${cpu}\"")
	else()
		message(WARNING "${CMAKE_C_COMPILER} -dumpmachine failed with error (code) ${cc_dumpmachine_res}")
		message(WARNING "will use the (sometimes incorrect) CMAKE_SYSTEM_PROCESSOR (${cpu}) to determine YQ2ARCH")
	endif()
endif()

if(cpu STREQUAL "powerpc")
	set(cpu "ppc")
elseif(cpu STREQUAL "aarch64")
	# "arm64" is more obvious, and some operating systems (like macOS) use it instead of "aarch64"
	set(cpu "arm64")
elseif(cpu MATCHES "i.86" OR cpu MATCHES "[xX]86")
	set(cpu "i386")
elseif(cpu MATCHES "[aA][mM][dD]64" OR cpu MATCHES "[xX]64")
	set(cpu "x86_64")
elseif(cpu MATCHES "[aA][rR][mM].*") # some kind of arm..
	# On 32bit Raspbian gcc -dumpmachine returns sth starting with "arm-",
	# while clang -dumpmachine says "arm6k-..." - try to unify that to "arm"
	if(CMAKE_SIZEOF_VOID_P EQUAL 8) # sizeof(void*) == 8 => must be arm64
		set(cpu "arm64")
	else() # should be 32bit arm then (probably "armv7l" "armv6k" or sth like that)
		set(cpu "arm")
	endif()
endif()

set(ARCH "${cpu}")

# END OF workarounds for CMake's poor choices regarding CPU architecture detection

add_definitions(-DYQ2ARCH="${ARCH}")

message(STATUS "Setting YQ2OSTYPE to \"${YQ2OSTYPE}\" and YQ2ARCH to \"${ARCH}\".")

# Systemwide installation of game assets.
if(${SYSTEMWIDE_SUPPORT})
    add_definitions(-DSYSTEMWIDE)
    if(NOT ${SYSTEMDIR} STREQUAL "")
      add_definitions(-DSYSTEMDIR="${SYSTEMDIR}")
    endif()
endif()

# We need to pass some options to minizip / unzip.
add_definitions(-DNOUNCRYPT)

if(NOT (CMAKE_SYSTEM_NAME MATCHES "Linux") AND NOT (CMAKE_SYSTEM_NAME MATCHES "Windows"))
	add_definitions(-DIOAPI_NO_64)
endif()

# Required libraries to build the different components of the binaries. Find
# them and add the include/linker directories and flags (in case the package
# manager find it in a weird place).
find_package(SDL2 REQUIRED)
list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})

# We need an OpenGL implementation.
set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL REQUIRED)
list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
list(APPEND yquake2OpenGLLinkerFlags ${OPENGL_LIBRARIES})

# backtrace lookup
# Some systems like Linux has it within the libc some like the BSD, Haiku ...
# into an external libexecinfo library
include(CheckFunctionExists)
include(CheckLibraryExists)
check_function_exists(backtrace HAVE_EXECINFO_SYS)
IF (NOT HAVE_EXECINFO_SYS)
	check_library_exists(execinfo backtrace "" HAVE_EXECINFO_LIB)
	if (HAVE_EXECINFO_LIB)
		list(APPEND yquake2ClientLinkerFlags execinfo)
		list(APPEND yquake2ServerLinkerFlags execinfo)
		add_definitions(-DHAVE_EXECINFO)
	endif()
else()
	add_definitions(-DHAVE_EXECINFO)
endif()

# cURL support.
if (${CURL_SUPPORT})
	find_package(CURL REQUIRED)
	add_definitions(-DUSE_CURL)
endif()

# OpenAL support.
if(${OPENAL_SUPPORT})
	find_package(OpenAL)

	if(${OPENAL_FOUND})
		list(APPEND yquake2IncludeDirectories "${OPENAL_INCLUDE_DIR}")
		list(APPEND yquake2ClientLinkerFlags ${OPENAL_LIBRARY})

		if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="openal32.dll")
		elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.dylib")
		elseif((${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD") OR (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD"))
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.so")
		else()
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.so.1")
		endif()
	endif()
endif()

# General linker flags.
if(NOT MSVC)
	list(APPEND yquake2LinkerFlags m)
endif()
list(APPEND yquake2LinkerFlags ${CMAKE_DL_LIBS})

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	if(!MSVC)
		list(APPEND yquake2LinkerFlags "-static-libgcc")
	endif()
else()
	if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
		list(APPEND yquake2LinkerFlags "-rdynamic")
	else()
		list(APPEND yquake2LinkerFlags "-lnetwork")
                set(CMAKE_POSITION_INDEPENDENT_CODE ON)
	endif()
	if (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
		list(APPEND yquake2LinkerFlags "-lsocket -lnsl")
	endif()
endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD" AND NOT WIN32)
	list(APPEND yquake2LinkerFlags "-Wl,--no-undefined")
endif()

# With all of those libraries and user defined paths
# added, lets give them to the compiler and linker.
include_directories(${yquake2IncludeDirectories})
link_directories(${yquake2LinkerDirectories})

# If we're building with gcc for i386 let's define -ffloat-store.
# This helps the old and crappy x87 FPU to produce correct values.
# Would be nice if Clang had something comparable.
if ("${ARCH}" STREQUAL "i386")
	if (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffloat-store")
	endif()
endif()

# Force SSE math on x86_64. All sane compilers should do this
# anyway, just to protect us from broken Linux distros.
if ("${ARCH}" STREQUAL "x86_64")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
endif()

if ("${ARCH}" STREQUAL "arm")
    if (CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=armv6k")
    endif()
endif()

set(Backends-Generic-Source
	${BACKENDS_SRC_DIR}/generic/misc.c
	)

set(Backends-Unix-Source
	${BACKENDS_SRC_DIR}/unix/main.c
	${BACKENDS_SRC_DIR}/unix/network.c
	${BACKENDS_SRC_DIR}/unix/signalhandler.c
	${BACKENDS_SRC_DIR}/unix/system.c
	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
	)

set(Backends-Windows-Source
	${BACKENDS_SRC_DIR}/windows/icon.rc
	${BACKENDS_SRC_DIR}/windows/main.c
	${BACKENDS_SRC_DIR}/windows/network.c
	${BACKENDS_SRC_DIR}/windows/system.c
	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
	)

set(Backends-Windows-Header
	${BACKENDS_SRC_DIR}/windows/header/resource.h
	)

set(REF-Windows-Source
	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
	)

=== Makefile ===
# ------------------------------------------------------ #
# Makefile for the "Yamagi Quake 2 Client"               #
#                                                        #
# Just type "make" to compile the                        #
#  - Client (quake2)                                     #
#  - Server (q2ded)                                      #
#  - Quake II Game (baseq2)                              #
#  - Renderer libraries (gl1, gl3, soft)                 #
#                                                        #
# Base dependencies:                                     #
#  - SDL 2.0                                             #
#  - libGL                                               #
#  - Vulkan headers                                      #
#                                                        #
# Optional dependencies:                                 #
#  - CURL                                                #
#  - OpenAL                                              #
#                                                        #
# Platforms:                                             #
#  - FreeBSD                                             #
#  - Linux                                               #
#  - NetBSD                                              #
#  - OpenBSD                                             #
#  - OS X                                                #
#  - Windows (MinGW)                                     #
# ------------------------------------------------------ #

# Variables
# ---------

# - ASAN: Builds with address sanitizer, includes DEBUG.
# - DEBUG: Builds a debug build, forces -O0 and adds debug symbols.
# - VERBOSE: Prints full compile, linker and misc commands.
# - UBSAN: Builds with undefined behavior sanitizer, includes DEBUG.

# ----------

# User configurable options
# -------------------------

# Enables HTTP support through cURL. Used for
# HTTP download.
WITH_CURL:=yes

# Enables the optional OpenAL sound system.
# To use it your system needs libopenal.so.1
# or openal32.dll (we recommend openal-soft)
# installed
WITH_OPENAL:=yes

# Sets an RPATH to $ORIGIN/lib. It can be used to
# inject custom libraries, e.g. a patches libSDL.so
# or libopenal.so. Not supported on Windows.
WITH_RPATH:=yes

# Enable systemwide installation of game assets.
WITH_SYSTEMWIDE:=no

# This will set the default SYSTEMDIR, a non-empty string
# would actually be used. On Windows normals slashes (/)
# instead of backslashed (\) should be used! The string
# MUST NOT be surrounded by quotation marks!
WITH_SYSTEMDIR:=""

# This will set the build options to create an MacOS .app-bundle.
# The app-bundle itself will not be created, but the runtime paths
# will be set to expect the game-data in *.app/
# Contents/Resources
OSX_APP:=yes

# This is an optional configuration file, it'll be used in
# case of presence.
CONFIG_FILE:=config.mk

# ----------

# In case a of a configuration file being present, we'll just use it
ifeq ($(wildcard $(CONFIG_FILE)), $(CONFIG_FILE))
include $(CONFIG_FILE)
endif

# Detect the OS
ifdef SystemRoot
YQ2_OSTYPE ?= Windows
else
YQ2_OSTYPE ?= $(shell uname -s)
endif

# Special case for MinGW
ifneq (,$(findstring MINGW,$(YQ2_OSTYPE)))
YQ2_OSTYPE := Windows
endif

# Detect the architecture
ifeq ($(YQ2_OSTYPE), Windows)
ifdef MINGW_CHOST
ifeq ($(MINGW_CHOST), x86_64-w64-mingw32)
YQ2_ARCH ?= x86_64
else # i686-w64-mingw32
YQ2_ARCH ?= i386
endif
else # windows, but MINGW_CHOST not defined
ifdef PROCESSOR_ARCHITEW6432
# 64 bit Windows
YQ2_ARCH ?= $(PROCESSOR_ARCHITEW6432)
else
# 32 bit Windows
YQ2_ARCH ?= $(PROCESSOR_ARCHITECTURE)
endif
endif # windows but MINGW_CHOST not defined
else
ifneq ($(YQ2_OSTYPE), Darwin)
# Normalize some abiguous YQ2_ARCH strings
YQ2_ARCH ?= $(shell uname -m | sed -e 's/i.86/i386/' -e 's/amd64/x86_64/' -e 's/arm64/aarch64/' -e 's/^arm.*/arm/')
else
YQ2_ARCH ?= $(shell uname -m)
endif
endif

# Detect the compiler
ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
COMPILER := clang
COMPILERVER := $(shell $(CC)  -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/')
else ifeq ($(shell $(CC) -v 2>&1 | grep -c -E "(gcc version|gcc-Version)"), 1)
COMPILER := gcc
COMPILERVER := $(shell $(CC)  -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/')
else
COMPILER := unknown
endif

# ASAN includes DEBUG
ifdef ASAN
DEBUG=1
endif

# UBSAN includes DEBUG
ifdef UBSAN
DEBUG=1
endif

# ----------

# Base CFLAGS. These may be overridden by the environment.
# Highest supported optimizations are -O2, higher levels
# will likely break this crappy code.
ifdef DEBUG
CFLAGS ?= -O0 -g -Wall -pipe
ifdef ASAN
override CFLAGS += -fsanitize=address -DUSE_SANITIZER
endif
ifdef UBSAN
override CFLAGS += -fsanitize=undefined -DUSE_SANITIZER
endif
else
CFLAGS ?= -O2 -Wall -pipe -fomit-frame-pointer
endif

# Always needed are:
#  -fno-strict-aliasing since the source doesn't comply
#   with strict aliasing rules and it's next to impossible
#   to get it there...
#  -fwrapv for defined integer wrapping. MSVC6 did this
#   and the game code requires it.
#  -fvisibility=hidden to keep symbols hidden. This is
#   mostly best practice and not really necessary.
override CFLAGS += -std=gnu99 -fno-strict-aliasing -fwrapv -fvisibility=hidden

# -MMD to generate header dependencies. Unsupported by
#  the Clang shipped with OS X.
ifneq ($(YQ2_OSTYPE), Darwin)
override CFLAGS += -MMD
endif

# OS X architecture.
ifeq ($(YQ2_OSTYPE), Darwin)
override CFLAGS += -arch $(YQ2_ARCH)
endif

# ----------

# ARM needs a sane minimum architecture. We need the `yield`
# opcode, arm6k is the first iteration that supports it. arm6k
# is also the first Raspberry PI generation and older hardware
# is likely too slow to run the game. We're not enforcing the
# minimum architecture, but if you're build for something older
# like arm5 the `yield` opcode isn't compiled in and the game
# (especially q2ded) will consume more CPU time than necessary.
ifeq ($(YQ2_ARCH), arm)
CFLAGS += -march=armv6k
endif

# ----------

# Switch of some annoying warnings.
ifeq ($(COMPILER), clang)
	# -Wno-missing-braces because otherwise clang complains
	#  about totally valid 'vec3_t bla = {0}' constructs.
	override CFLAGS += -Wno-missing-braces
else ifeq ($(COMPILER), gcc)
	# GCC 8.0 or higher.
	ifeq ($(shell test $(COMPILERVER) -ge 80000; echo $$?),0)
	    # -Wno-format-truncation and -Wno-format-overflow
		# because GCC spams about 50 false positives.
		override CFLAGS += -Wno-format-truncation -Wno-format-overflow
	endif
endif

# ----------

# Defines the operating system and architecture
override CFLAGS += -DYQ2OSTYPE=\"$(YQ2_OSTYPE)\" -DYQ2ARCH=\"$(YQ2_ARCH)\"

# ----------

# For reproduceable builds, look here for details:
# https://reproducible-builds.org/specs/source-date-epoch/
ifdef SOURCE_DATE_EPOCH
override CFLAGS += -DBUILD_DATE=\"$(shell date --utc --date="@${SOURCE_DATE_EPOCH}" +"%b %_d %Y" | sed -e 's/ /\\ /g')\"
endif

# ----------

# Using the default x87 float math on 32bit x86 causes rounding trouble
# -ffloat-store could work around that, but the better solution is to
# just enforce SSE - every x86 CPU since Pentium3 supports that
# and this should even improve the performance on old CPUs
ifeq ($(YQ2_ARCH), i386)
override CFLAGS += -msse -mfpmath=sse
endif

# Force SSE math on x86_64. All sane compilers should do this
# anyway, just to protect us from broken Linux distros.
ifeq ($(YQ2_ARCH), x86_64)
override CFLAGS += -mfpmath=sse
endif

# Disable floating-point expression contraction. While this shouldn't be
# a problem for C (only for C++) better be safe than sorry. See
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=100839 for details.
ifeq ($(COMPILER), gcc)
override CFLAGS += -ffp-contract=off
endif

# ----------

# Systemwide installation.
ifeq ($(WITH_SYSTEMWIDE),yes)
override CFLAGS += -DSYSTEMWIDE
ifneq ($(WITH_SYSTEMDIR),"")
override CFLAGS += -DSYSTEMDIR=\"$(WITH_SYSTEMDIR)\"
endif
endif

# ----------

# We don't support encrypted ZIP files.
ZIPCFLAGS := -DNOUNCRYPT

# Just set IOAPI_NO_64 on everything that's not Linux or Windows,
# otherwise minizip will use fopen64(), fseek64() and friends that
# may be unavailable. This is - of course - not really correct, in
# a better world we would set -DIOAPI_NO_64 to force everything to
# fopen(), fseek() and so on and -D_FILE_OFFSET_BITS=64 to let the
# libc headers do their work. Currently we can't do that because
# Quake II uses nearly everywere int instead of off_t...
#
# This may have the side effect that ZIP files larger than 2GB are
# unsupported. But I doubt that anyone has such large files, they
# would likely hit other internal limits.
ifneq ($(YQ2_OSTYPE),Windows)
ifneq ($(YQ2_OSTYPE),Linux)
ZIPCFLAGS += -DIOAPI_NO_64
endif
endif

# ----------

# Extra CFLAGS for SDL.
SDLCFLAGS := $(shell sdl2-config --cflags)

# ----------

# Base include path.
ifeq ($(YQ2_OSTYPE),Linux)
INCLUDE ?= -I/usr/include
else ifeq ($(YQ2_OSTYPE),FreeBSD)
INCLUDE ?= -I/usr/local/include
else ifeq ($(YQ2_OSTYPE),NetBSD)
INCLUDE ?= -I/usr/X11R7/include -I/usr/pkg/include
else ifeq ($(YQ2_OSTYPE),OpenBSD)
INCLUDE ?= -I/usr/local/include
else ifeq ($(YQ2_OSTYPE),Windows)
INCLUDE ?= -I/usr/include
endif

# ----------

# Base LDFLAGS. This is just the library path.
ifeq ($(YQ2_OSTYPE),Linux)
LDFLAGS ?= -L/usr/lib
else ifeq ($(YQ2_OSTYPE),FreeBSD)
LDFLAGS ?= -L/usr/local/lib
else ifeq ($(YQ2_OSTYPE),NetBSD)
LDFLAGS ?= -L/usr/X11R7/lib -Wl,-R/usr/X11R7/lib -L/usr/pkg/lib -Wl,-R/usr/pkg/lib
else ifeq ($(YQ2_OSTYPE),OpenBSD)
LDFLAGS ?= -L/usr/local/lib
else ifeq ($(YQ2_OSTYPE),Windows)
LDFLAGS ?= -L/usr/lib
endif

# Link address sanitizer if requested.
ifdef ASAN
override LDFLAGS += -fsanitize=address
endif

# Link undefined behavior sanitizer if requested.
ifdef UBSAN
override LDFLAGS += -fsanitize=undefined
endif

# Required libraries.
ifeq ($(YQ2_OSTYPE),Linux)
LDLIBS ?= -lm -ldl -rdynamic
else ifeq ($(YQ2_OSTYPE),FreeBSD)
LDLIBS ?= -lm
else ifeq ($(YQ2_OSTYPE),NetBSD)
LDLIBS ?= -lm
else ifeq ($(YQ2_OSTYPE),OpenBSD)
LDLIBS ?= -lm
else ifeq ($(YQ2_OSTYPE),Windows)
LDLIBS ?= -lws2_32 -lwinmm -static-libgcc
else ifeq ($(YQ2_OSTYPE), Darwin)
LDLIBS ?= -arch $(YQ2_ARCH)
else ifeq ($(YQ2_OSTYPE), Haiku)
LDLIBS ?= -lm -lnetwork
else ifeq ($(YQ2_OSTYPE), SunOS)
LDLIBS ?= -lm -lsocket -lnsl
endif

# ASAN and UBSAN must not be linked
# with --no-undefined. OSX and OpenBSD
# don't support it at all.
ifndef ASAN
ifndef UBSAN
ifneq ($(YQ2_OSTYPE), Darwin)
ifneq ($(YQ2_OSTYPE), OpenBSD)
override LDFLAGS += -Wl,--no-undefined
endif
endif
endif
endif

# ----------

# Extra LDFLAGS for SDL
ifeq ($(YQ2_OSTYPE), Darwin)
SDLLDFLAGS := -lSDL2
else # not Darwin
SDLLDFLAGS := $(shell sdl2-config --libs)
endif # Darwin

# The renderer libs don't need libSDL2main, libmingw32 or -mwindows.
ifeq ($(YQ2_OSTYPE), Windows)
DLL_SDLLDFLAGS = $(subst -mwindows,,$(subst -lmingw32,,$(subst -lSDL2main,,$(SDLLDFLAGS))))
endif

# ----------

# When make is invoked by "make VERBOSE=1" print
# the compiler and linker commands.
ifdef VERBOSE
Q :=
else
Q := @
endif

# ----------

# Phony targets
.PHONY : all client game icon server ref_gl1 ref_gl3 ref_gles3 ref_soft

# ----------

# Builds everything
all: config client server game ref_gl1 ref_gl3 ref_gles3 ref_soft

# ----------

# Print config values
config:
	@echo "Build configuration"
	@echo "============================"
	@echo "YQ2_ARCH = $(YQ2_ARCH) COMPILER = $(COMPILER)"
	@echo "WITH_CURL = $(WITH_CURL)"
	@echo "WITH_OPENAL = $(WITH_OPENAL)"
	@echo "WITH_RPATH = $(WITH_RPATH)"
	@echo "WITH_SYSTEMWIDE = $(WITH_SYSTEMWIDE)"
	@echo "WITH_SYSTEMDIR = $(WITH_SYSTEMDIR)"
	@echo "============================"
	@echo ""

# ----------

# Special target to compile the icon on Windows
ifeq ($(YQ2_OSTYPE), Windows)
icon:
	@echo "===> WR build/icon/icon.res"
	${Q}mkdir -p build/icon

=== debian/watch ===
version=4
# TODO: the CTF version is hard-coded here, but I don't see a way around that
opts="repack,compression=gz,uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/\+ctf.*//,oversionmangle=s/$/+ctf1.09+dfsg/" \
 https://github.com/yquake2/yquake2/tags .*/QUAKE2_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=ctf,oversionmangle=s/$/+ctf1.09+dfsg/" \
 https://github.com/yquake2/ctf/tags .*/CTF_(.*)\.tar\.gz

## yquake2 8.30+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 	# ignore some compiler warnings
 	add_compile_options(/wd4244 /wd4305) # possible loss of data/truncation (double to float etc; ignore)
-	add_compile_options(/wd4018) # signed/unsigned missmatch
+	add_compile_options(/wd4018) # signed/unsigned mismatch
 	add_compile_options(/wd4996) # 'function': was declared deprecated (like all that secure CRT stuff)
 	# don't show me warnings for system headers, why the fuck isn't this default
 	add_compile_options(/experimental:external /external:W0)
@@ -107,21 +107,9 @@
 	# special case: cross-compiling, here CMAKE_SYSTEM_PROCESSOR should be correct, hopefully
 	# (just leave cpu at ${CMAKE_SYSTEM_PROCESSOR})
 elseif(MSVC)
-	message(DEBUG "CMAKE_GENERATOR_PLATFORM: ${CMAKE_GENERATOR_PLATFORM}")
-	if(CMAKE_GENERATOR_PLATFORM STREQUAL "Win32")
-		set(cpu "i386")
-	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "x64")
-		set(cpu "x86_64")
-	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM")
-		# at least on RPi 32bit, gcc -dumpmachine outputs "arm-linux-gnueabihf",
-		#  so we'll use "arm" there => use the same for 32bit ARM on MSVC
-		set(cpu "arm")
-	elseif(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
-		set(cpu "arm64")
-	else()
-		message(FATAL_ERROR "Unknown Target CPU/platform ${CMAKE_GENERATOR_PLATFORM}")
-	endif()
-	message(DEBUG "  => CPU architecture extracted from that: \"${cpu}\"")
+	# because all this wasn't ugly enough, it turned out that, unlike standalone CMake, Visual Studio's
+	# integrated CMake doesn't set CMAKE_GENERATOR_PLATFORM, so I gave up on guessing the CPU arch here
+	# and moved the CPU detection to MSVC-specific code in neo/sys/platform.h
 else() # not MSVC and not cross-compiling, assume GCC or clang (-compatible), seems to work for MinGW as well
 	execute_process(COMMAND ${CMAKE_C_COMPILER} "-dumpmachine"
 	                RESULT_VARIABLE cc_dumpmachine_res
@@ -145,10 +133,10 @@
 elseif(cpu STREQUAL "aarch64")
 	# "arm64" is more obvious, and some operating systems (like macOS) use it instead of "aarch64"
 	set(cpu "arm64")
+elseif(cpu MATCHES "[aA][mM][dD]64" OR cpu MATCHES "[xX].*64")
+	set(cpu "x86_64")
 elseif(cpu MATCHES "i.86" OR cpu MATCHES "[xX]86")
 	set(cpu "i386")
-elseif(cpu MATCHES "[aA][mM][dD]64" OR cpu MATCHES "[xX]64")
-	set(cpu "x86_64")
 elseif(cpu MATCHES "[aA][rR][mM].*") # some kind of arm..
 	# On 32bit Raspbian gcc -dumpmachine returns sth starting with "arm-",
 	# while clang -dumpmachine says "arm6k-..." - try to unify that to "arm"
@@ -159,13 +147,19 @@
 	endif()
 endif()
 
-set(ARCH "${cpu}")
+if(MSVC)
+	# for MSVC YQ2ARCH is set in code (in src/common/header/common.h)
+	message(STATUS "Setting YQ2OSTYPE to \"${YQ2OSTYPE}\" - NOT setting YQ2ARCH, because we're targeting MSVC (VisualC++)")
+else()
+	set(ARCH "${cpu}")
+	add_definitions(-DYQ2ARCH="${ARCH}")
+	message(STATUS "Setting YQ2OSTYPE to \"${YQ2OSTYPE}\" and YQ2ARCH to \"${ARCH}\".")
+endif()
+# make sure that ${cpu} isn't used below - if at all use ${ARCH}, but not when compiling with MSVC!
+unset(cpu)
 
 # END OF workarounds for CMake's poor choices regarding CPU architecture detection
 
-add_definitions(-DYQ2ARCH="${ARCH}")
-
-message(STATUS "Setting YQ2OSTYPE to \"${YQ2OSTYPE}\" and YQ2ARCH to \"${ARCH}\".")
 
 # Systemwide installation of game assets.
 if(${SYSTEMWIDE_SUPPORT})
@@ -269,25 +263,26 @@
 include_directories(${yquake2IncludeDirectories})
 link_directories(${yquake2LinkerDirectories})
 
-# If we're building with gcc for i386 let's define -ffloat-store.
-# This helps the old and crappy x87 FPU to produce correct values.
-# Would be nice if Clang had something comparable.
-if ("${ARCH}" STREQUAL "i386")
-	if (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
+# these settings only work for GCC and clang
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
+	# If we're building with gcc for i386 let's define -ffloat-store.
+	# This helps the old and crappy x87 FPU to produce correct values.
+	# Would be nice if Clang had something comparable.
+	if ("${ARCH}" STREQUAL "i386" AND ${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffloat-store")
 	endif()
-endif()
-
-# Force SSE math on x86_64. All sane compilers should do this
-# anyway, just to protect us from broken Linux distros.
-if ("${ARCH}" STREQUAL "x86_64")
-	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
-endif()
-
-if ("${ARCH}" STREQUAL "arm")
-    if (CMAKE_SIZEOF_VOID_P EQUAL 4)
-        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=armv6k")
-    endif()
+
+	# Force SSE math on x86_64. All sane compilers should do this
+	# anyway, just to protect us from broken Linux distros.
+	if ("${ARCH}" STREQUAL "x86_64")
+		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
+	endif()
+
+	if ("${ARCH}" STREQUAL "arm")
+		if (CMAKE_SIZEOF_VOID_P EQUAL 4)
+			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=armv6k")
+		endif()
+	endif()
 endif()
 
 set(Backends-Generic-Source
@@ -314,7 +309,3 @@
 	${BACKENDS_SRC_DIR}/windows/header/resource.h
 	)
 
-set(REF-Windows-Source
-	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
-	)
-

=== Makefile ===
--- 
+++ 
@@ -163,7 +163,7 @@
 #   and the game code requires it.
 #  -fvisibility=hidden to keep symbols hidden. This is
 #   mostly best practice and not really necessary.
-override CFLAGS += -std=gnu99 -fno-strict-aliasing -fwrapv -fvisibility=hidden
+override CFLAGS += -fno-strict-aliasing -fwrapv -fvisibility=hidden
 
 # -MMD to generate header dependencies. Unsupported by
 #  the Clang shipped with OS X.

=== debian/changelog ===
yquake2 (8.30+dfsg-1) unstable; urgency=medium

  * Add game-code for official expansion packs.
    Now that id Software has re-released the expansion packs' game code
    under the GPL (as opposed to the previous non-free SDK license), the
    yquake2 project has obtained permission from its other contributors
    to relicense similarly, reverting a few changes for which no such
    permission was obtained.
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Sun, 10 Dec 2023 22:24:53 +0000

yquake2 (8.30+ctf1.10+dfsg-1) unstable; urgency=medium

  * New upstream release 8.30 (engine and base game)
  * New upstream release 1.10 (CTF game)
  * d/gbp.conf: Use debian/latest branch for packaging

 -- Simon McVittie <smcv@debian.org>  Sun, 10 Dec 2023 18:54:26 +0000

=== debian/control ===
Source: yquake2
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libcurl4-gnutls-dev | libcurl-dev,
 libgl-dev,
 libopenal-dev,
 libsdl2-dev,
 libvorbis-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://www.yamagi.org/quake2/
Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
Vcs-Browser: https://salsa.debian.org/games-team/yquake2

Package: yamagi-quake2
Architecture: linux-any
Depends:
 libgl1,
 yamagi-quake2-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libopenal1,
 quake2,
Suggests:
 libcurl3-gnutls | libcurl4 | libcurl3-nss | libcurl3,
Provides: quake2-engine
Description: enhanced version of id Software's Quake II - client
 This is the Yamagi Quake II Client, an enhanced Version of id Software's
 Quake II. The main focus is single player, the gameplay and the graphics are
 unchanged, but many bugs were fixed. This code is based upon Icculus Quake II,
 which itself is built upon id Software's original code drop. Additional code
 and patches by many contributors were used.
 .
 This engine is intended to be used via the wrapper script and menu entries
 in the quake2 package.

Package: yamagi-quake2-core
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: quake2-server | yamagi-quake2
Provides: quake2-engine-server
Description: enhanced version of id Software's Quake II - non-GUI part
 This is the Yamagi Quake II Server, an enhanced Version of id Software's
 Quake II. This code is based upon Icculus Quake II,
 which itself is built upon id Software's original code drop. Additional code
 and patches by many contributors were used.
 .
 This package contains files common to the client and the server, and a
 dedicated server engine is intended to be used via the wrapper script
 and init scripts in the quake2-server package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export LC_ALL=C.UTF-8
export TZ=UTC

DEB_LDFLAGS_MAINT_APPEND  += -Wl,-z,defs
export DEB_LDFLAGS_MAINT_APPEND
DPKG_EXPORT_BUILDFLAGS = yes
include /usr/share/dpkg/default.mk
export CFLAGS += $(CPPFLAGS)

%:
	dh $@

export LC_ALL=C.UTF-8
export TZ=UTC

# YQ2_ARCH is meant to be uname -m, except that i?86, amd64 and arm*
# are normalized to i386, x86_64 and arm respectively; the value matters,
# because it appears in saved games. Newer CPU architectures tend to have
# the GNU CPU name be the same as the Linux uname -m, because anything
# else would be pointless complication.
ifeq ($(DEB_HOST_ARCH_CPU),i386)
# Don't use i686 here
YQ2_ARCH=i386
else ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
# Linux and GNU disagree on the canonical name of this architecture
YQ2_ARCH=ppc
else ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
# Linux and GNU disagree on the canonical name of this architecture
YQ2_ARCH=ppc64le
else
# This is the same as uname -m on most architectures. On ARM it's just
# "arm" which is what we wanted anyway.
YQ2_ARCH=$(DEB_HOST_GNU_CPU)
endif

# Similarly, YQ2_OSTYPE is meant to be uname -s.
ifeq ($(DEB_HOST_ARCH_OS),linux)
YQ2_OSTYPE=Linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
YQ2_OSTYPE=GNU/kFreeBSD
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
YQ2_OSTYPE=GNU
else
$(error Set YQ2_OSTYPE to the value of uname -s on $(DEB_HOST_ARCH))
endif

subdirs = subdir-ctf subdir-rogue subdir-xatrix

override_dh_auto_build: $(subdirs)
	dh_auto_build -- \
		VERBOSE=1 \
		WITH_RPATH=no \
		WITH_SYSTEMWIDE=yes \
		YQ2_ARCH=$(YQ2_ARCH) \
		YQ2_OSTYPE=$(YQ2_OSTYPE) \
		${NULL}

.PHONY: $(subdirs)
$(subdirs): subdir-%:
	dh_auto_build --sourcedirectory=$* -- \
		VERBOSE=1 \
		YQ2_ARCH=$(YQ2_ARCH) \
		YQ2_OSTYPE=$(YQ2_OSTYPE) \
		${NULL}

override_dh_install:
	install -d debian/tmp/ctf
	install -d debian/tmp/rogue
	install -d debian/tmp/xatrix
	install -m644 CHANGELOG debian/tmp/NEWS
	install -m644 ctf/CHANGELOG debian/tmp/ctf/NEWS
	install -m644 rogue/CHANGELOG debian/tmp/rogue/NEWS
	install -m644 xatrix/CHANGELOG debian/tmp/xatrix/NEWS
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs -XCHANGELOG

override_dh_installdocs:
	dh_installdocs README.md doc/*.md

=== debian/watch ===
version=4
# TODO: the side projects' versions are hard-coded here, but I don't see a way around that
opts="repack,compression=gz,uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/\+ctf.*//,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/yquake2/tags .*/QUAKE2_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=ctf,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/ctf/tags .*/CTF_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=rogue,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/rogue/tags .*/ROGUE_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=xatrix,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/xatrix/tags .*/XATRIX_(.*)\.tar\.gz

## yquake2 8.40+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -64,6 +64,7 @@
 option(CURL_SUPPORT "cURL support" ON)
 option(OPENAL_SUPPORT "OpenAL support" ON)
 option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)
+option(SDL3_SUPPORT "Build against SDL 3 instead of SDL2" OFF)
 
 set(SYSTEMDIR "" CACHE STRING "Override the system default directory")
 
@@ -179,9 +180,14 @@
 # Required libraries to build the different components of the binaries. Find
 # them and add the include/linker directories and flags (in case the package
 # manager find it in a weird place).
-find_package(SDL2 REQUIRED)
-list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
-list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
+if (SDL3_SUPPORT)
+	find_package(SDL3 REQUIRED)
+	add_definitions(-DUSE_SDL3)
+else()
+	find_package(SDL2 REQUIRED)
+	list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
+	list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
+endif()
 
 # We need an OpenGL implementation.
 set(OpenGL_GL_PREFERENCE GLVND)
@@ -301,11 +307,3 @@
 	${BACKENDS_SRC_DIR}/windows/icon.rc
 	${BACKENDS_SRC_DIR}/windows/main.c
 	${BACKENDS_SRC_DIR}/windows/network.c
-	${BACKENDS_SRC_DIR}/windows/system.c
-	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
-	)
-
-set(Backends-Windows-Header
-	${BACKENDS_SRC_DIR}/windows/header/resource.h
-	)
-

=== debian/changelog ===
yquake2 (8.40+dfsg-1) unstable; urgency=medium

  * New upstream release 8.40 (engine and base game)
  * New upstream release 2.13 (The Reckoning / xatrix)
  * New upstream release 2.12 (Ground Zero / rogue)
  * d/copyright: Update
  * Standards-Version: 4.7.0 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Wed, 31 Jul 2024 10:50:04 +0100

## yquake2 8.41+dfsg

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 #  - Renderer libraries (gl1, gl3, soft)                 #
 #                                                        #
 # Base dependencies:                                     #
-#  - SDL 2.0                                             #
+#  - SDL 2 or SDL 3                                      #
 #  - libGL                                               #
 #  - Vulkan headers                                      #
 #                                                        #
@@ -53,6 +53,9 @@
 # or libopenal.so. Not supported on Windows.
 WITH_RPATH:=yes
 
+# Builds with SDL 3 instead of SDL 2.
+WITH_SDL3:=no
+
 # Enable systemwide installation of game assets.
 WITH_SYSTEMWIDE:=no
 
@@ -144,7 +147,7 @@
 # Highest supported optimizations are -O2, higher levels
 # will likely break this crappy code.
 ifdef DEBUG
-CFLAGS ?= -O0 -g -Wall -pipe
+CFLAGS ?= -O0 -g -Wall -pipe -DDEBUG
 ifdef ASAN
 override CFLAGS += -fsanitize=address -DUSE_SANITIZER
 endif
@@ -276,7 +279,12 @@
 # ----------
 
 # Extra CFLAGS for SDL.
+ifeq ($(WITH_SDL3),yes)
+SDLCFLAGS := $(shell pkgconf --cflags sdl3)
+SDLCFLAGS += -DUSE_SDL3
+else
 SDLCFLAGS := $(shell sdl2-config --cflags)
+endif
 
 # ----------
 
@@ -291,6 +299,8 @@
 INCLUDE ?= -I/usr/local/include
 else ifeq ($(YQ2_OSTYPE),Windows)
 INCLUDE ?= -I/usr/include
+else ifeq ($(YQ2_OSTYPE),Darwin)
+INCLUDE ?= -I/usr/local/include -I/opt/homebrew/include
 endif
 
 # ----------
@@ -306,6 +316,8 @@
 LDFLAGS ?= -L/usr/local/lib
 else ifeq ($(YQ2_OSTYPE),Windows)
 LDFLAGS ?= -L/usr/lib
+else ifeq ($(YQ2_OSTYPE),Darwin)
+LDFLAGS ?= -L/usr/local/lib -L/opt/homebrew/lib
 endif
 
 # Link address sanitizer if requested.
@@ -353,11 +365,19 @@
 # ----------
 
 # Extra LDFLAGS for SDL
+ifeq ($(WITH_SDL3),yes)
+ifeq ($(YQ2_OSTYPE), Darwin)
+SDLLDFLAGS := -lSDL3
+else
+SDLLDFLAGS := $(shell pkgconf --libs sdl3)
+endif
+else
 ifeq ($(YQ2_OSTYPE), Darwin)
 SDLLDFLAGS := -lSDL2
-else # not Darwin
+else
 SDLLDFLAGS := $(shell sdl2-config --libs)
-endif # Darwin
+endif
+endif
 
 # The renderer libs don't need libSDL2main, libmingw32 or -mwindows.
 ifeq ($(YQ2_OSTYPE), Windows)
@@ -391,18 +411,3 @@
 	@echo "Build configuration"
 	@echo "============================"
 	@echo "YQ2_ARCH = $(YQ2_ARCH) COMPILER = $(COMPILER)"
-	@echo "WITH_CURL = $(WITH_CURL)"
-	@echo "WITH_OPENAL = $(WITH_OPENAL)"
-	@echo "WITH_RPATH = $(WITH_RPATH)"
-	@echo "WITH_SYSTEMWIDE = $(WITH_SYSTEMWIDE)"
-	@echo "WITH_SYSTEMDIR = $(WITH_SYSTEMDIR)"
-	@echo "============================"
-	@echo ""
-
-# ----------
-
-# Special target to compile the icon on Windows
-ifeq ($(YQ2_OSTYPE), Windows)
-icon:
-	@echo "===> WR build/icon/icon.res"
-	${Q}mkdir -p build/icon

=== debian/changelog ===
yquake2 (8.41+dfsg-1) unstable; urgency=medium

  * New upstream release (engine and base game only)

 -- Simon McVittie <smcv@debian.org>  Fri, 06 Sep 2024 22:02:53 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libxxf86vm-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://www.yamagi.org/quake2/
 Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
 Vcs-Browser: https://salsa.debian.org/games-team/yquake2

=== debian/watch ===
--- 
+++ 
@@ -1,5 +1,4 @@
 version=4
-# TODO: the side projects' versions are hard-coded here, but I don't see a way around that
 opts="repack,compression=gz,uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/\+ctf.*//,oversionmangle=s/$/+dfsg/" \
  https://github.com/yquake2/yquake2/tags .*/QUAKE2_(.*)\.tar\.gz
 opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g;s/.*\+ctf//,component=ctf,oversionmangle=s/$/+dfsg/" \

## yquake2 8.50+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
 
 # Print a message that using the Makefiles is recommended.
 message(NOTICE: " The CMakeLists.txt is unmaintained. Use the Makefile if possible.")
@@ -65,6 +65,11 @@
 option(OPENAL_SUPPORT "OpenAL support" ON)
 option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)
 option(SDL3_SUPPORT "Build against SDL 3 instead of SDL2" OFF)
+option(GL1_RENDERER "Build the GL1 renderer" ON)
+option(GL3_RENDERER "Build the GL3 renderer" ON)
+option(GLES1_RENDERER "Build the GLES1 renderer" OFF)
+option(GLES3_RENDERER "Build the GLES3 renderer" ON)
+option(SOFT_RENDERER "Build the software renderer" ON)
 
 set(SYSTEMDIR "" CACHE STRING "Override the system default directory")
 
@@ -189,11 +194,13 @@
 	list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
 endif()
 
-# We need an OpenGL implementation.
-set(OpenGL_GL_PREFERENCE GLVND)
-find_package(OpenGL REQUIRED)
-list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
-list(APPEND yquake2OpenGLLinkerFlags ${OPENGL_LIBRARIES})
+if(GL1_RENDERER)
+     # We need an OpenGL implementation.
+     set(OpenGL_GL_PREFERENCE GLVND)
+     find_package(OpenGL REQUIRED)
+     list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
+     list(APPEND yquake2OpenGLLinkerFlags ${OPENGL_LIBRARIES})
+endif()
 
 # backtrace lookup
 # Some systems like Linux has it within the libc some like the BSD, Haiku ...
@@ -297,13 +304,3 @@
 
 set(Backends-Unix-Source
 	${BACKENDS_SRC_DIR}/unix/main.c
-	${BACKENDS_SRC_DIR}/unix/network.c
-	${BACKENDS_SRC_DIR}/unix/signalhandler.c
-	${BACKENDS_SRC_DIR}/unix/system.c
-	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
-	)
-
-set(Backends-Windows-Source
-	${BACKENDS_SRC_DIR}/windows/icon.rc
-	${BACKENDS_SRC_DIR}/windows/main.c
-	${BACKENDS_SRC_DIR}/windows/network.c

=== Makefile ===
--- 
+++ 
@@ -286,6 +286,10 @@
 SDLCFLAGS := $(shell sdl2-config --cflags)
 endif
 
+ifdef NO_SDL_GYRO
+SDLCFLAGS += -DNO_SDL_GYRO
+endif
+
 # ----------
 
 # Base include path.
@@ -397,17 +401,13 @@
 # ----------
 
 # Phony targets
-.PHONY : all client game icon server ref_gl1 ref_gl3 ref_gles3 ref_soft
-
-# ----------
-
-# Builds everything
+.PHONY : all client game icon server ref_gl1 ref_gl3 ref_gles1 ref_gles3 ref_soft
+
+# ----------
+
+# Builds everything but the GLES1 renderer
 all: config client server game ref_gl1 ref_gl3 ref_gles3 ref_soft
 
 # ----------
 
-# Print config values
-config:
-	@echo "Build configuration"
-	@echo "============================"
-	@echo "YQ2_ARCH = $(YQ2_ARCH) COMPILER = $(COMPILER)"
+# Builds everything, including the GLES1 renderer

=== debian/changelog ===
yquake2 (8.50+dfsg-1) unstable; urgency=medium

  * New upstream release 8.50 (engine and base game)
  * New upstream release 1.11 (Threewave Capture the Flag, ctf)
  * New upstream release 2.14 (Mission Pack 1: The Reckoning, xatrix)
  * New upstream release 2.13 (Mission Pack 2: Ground Zero, rogue)
  * d/salsa-ci.yml: Use recommended recipe
  * d/watch: Remove leftovers from +ctf versioning
  * d/watch: Specify that secondary components have different versioning
  * d/copyright: Update
  * Standards-Version: 4.7.2 (no changes required)
  * d/yamagi-quake2-core.install: Update README filenames

 -- Simon McVittie <smcv@debian.org>  Sun, 06 Apr 2025 13:03:46 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libxxf86vm-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://www.yamagi.org/quake2/
 Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
 Vcs-Browser: https://salsa.debian.org/games-team/yquake2

=== debian/watch ===
version=4
opts="repack,compression=gz,uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/yquake2/tags .*/QUAKE2_(.*)\.tar\.gz
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g,component=ctf,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/ctf/tags .*/CTF_(.*)\.tar\.gz ignore
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g,component=rogue,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/rogue/tags .*/ROGUE_(.*)\.tar\.gz ignore
opts="uversionmangle=s/_/./g;s/\.RC/~rc/gi,dversionmangle=s/[~+]dfsg[0-9]*//g,component=xatrix,oversionmangle=s/$/+dfsg/" \
 https://github.com/yquake2/xatrix/tags .*/XATRIX_(.*)\.tar\.gz ignore
